package com.zd.laboratory.service;

import com.zd.laboratory.domain.vo.LabManageWorkChartVo;
import com.zd.system.api.laboratory.domain.LabGradeManageRecord;

import java.util.List;
import java.util.Map;

/**
 * 管控执行记录Service接口
 *
 * @author liubo
 * @date 2022-02-10
 */
public interface ILabGradeManageRecordService {
    /**
     * 查询管控执行记录
     *
     * @param id 管控执行记录主键
     * @return 管控执行记录
     */
    public LabGradeManageRecord selectLabGradeManageRecordById(Long id);

    /**
     * 查询管控执行记录列表
     *
     * @param labGradeManageRecord 管控执行记录
     * @return 管控执行记录集合
     */
    public List<LabGradeManageRecord> selectLabGradeManageRecordList(LabGradeManageRecord labGradeManageRecord);

    /**
     * 新增管控执行记录
     *
     * @param labGradeManageRecord 管控执行记录
     * @return 结果
     */
    public LabGradeManageRecord insertLabGradeManageRecord(LabGradeManageRecord labGradeManageRecord);

    /**
     * 修改管控执行记录
     *
     * @param labGradeManageRecord 管控执行记录
     * @return 结果
     */
    public int updateLabGradeManageRecord(LabGradeManageRecord labGradeManageRecord);

    /**
     * 批量删除管控执行记录
     *
     * @param ids 需要删除的管控执行记录主键集合
     * @return 结果
     */
    public int deleteLabGradeManageRecordByIds(Long[] ids);

    /**
     * 删除管控执行记录信息
     *
     * @param id 管控执行记录主键
     * @return 结果
     */
    public int deleteLabGradeManageRecordById(Long id);

    void workArrange();

    void sendManageMsgBySiginUser(Long userId, Long subId);

    Map<String, Object> queryManageWorkInfo(LabManageWorkChartVo labManageWorkChartVo);

    List<List<Object>> queryManageWorkCharts(LabManageWorkChartVo labManageWorkChartVo);

    List<LabManageWorkChartVo> queryManageWorkChartDetails(LabManageWorkChartVo labManageWorkChartVo);

    void workOverdue();

    void workExecuteByDay(String cycle);

    void workExecute();
}
